/****************************************************************************/

/* dyld_patcher.c */

/****************************************************************************/

#include <stdio.h>
#include <string.h>

/****************************************************************************/

#define FALSE 0
#define TRUE  1

/****************************************************************************/

int is_correct_version ( FILE * );

/****************************************************************************/

/* Array de bytes a cambiar */

unsigned int change_table [] [ 5 ] =  {
                                        { 0x153c4 , 0x0a00005d , 0xe1a02002 , ( unsigned ) "BEQ     loc_2FE15540       " , ( unsigned ) "MOV     R2, R2"          },
                                        { 0x15418 , 0x1a000012 , 0xe1a02002 , ( unsigned ) "BNE     loc_2FE15468       " , ( unsigned ) "MOV     R2, R2"          },
                                        { 0x15420 , 0xe203c004 , 0xe203c0ff , ( unsigned ) "AND     R12, R3, #4        " , ( unsigned ) "AND     R12, R3, #0xFF"  },
                                        { 0x15468 , 0xe51700d4 , 0xea000034 , ( unsigned ) "LDR     R0, [R7,#-0xD4]    " , ( unsigned ) "B       loc_2FE15540"    },
                                        { 0x15540 , 0xe5970018 , 0xe3120010 , ( unsigned ) "LDR     R0, [R7,#0x18]     " , ( unsigned ) "TST     R2, #0x10"       },
                                        { 0x15544 , 0xe5d03063 , 0x0a000004 , ( unsigned ) "LDRB    R3, [R0,#0x63]     " , ( unsigned ) "BEQ     loc_2FE1555C"    },
                                        { 0x15548 , 0xe59f05e0 , 0xe51700a4 , ( unsigned ) "LDR     R0, =0x12B         " , ( unsigned ) "LDR     R0, [R7,#-0xA4]" },
                                        { 0x1554c , 0xe3530000 , 0xe5902004 , ( unsigned ) "CMP     R3, #0             " , ( unsigned ) "LDR     R2, [R0,#4]"     },
                                        { 0x15550 , 0x02473064 , 0xe3a01000 , ( unsigned ) "SUBEQ   R3, R7, #0x64      " , ( unsigned ) "MOV     R1, #0"          },
                                        { 0x15554 , 0x15173138 , 0xe5900000 , ( unsigned ) "LDRNE   R3, [R7,#-0x138]   " , ( unsigned ) "LDR     R0, [R0]"        },
                                        { 0x15558 , 0xe58d3000 , 0xeb003b74 , ( unsigned ) "STR R3, [SP,#0x184+var_184]" , ( unsigned ) "BL      _memset"         },
                                        { 0x1555c , 0xe3a03001 , 0xe51700d4 , ( unsigned ) "MOV R3, #1                 " , ( unsigned ) "LDR     R0, [R7,#-0xD4]" },
                                        { 0x15560 , 0xe5073094 , 0xeaffffc1 , ( unsigned ) "STR R3, [R7,#-0x94]        " , ( unsigned ) "B       loc_2FE1546C"    },
                                      };

/****************************************************************************/

int main ( int argc , char *argv [] )
{
  FILE *dyld_source;
  FILE *dyld_dest;
  unsigned int pos;
  int c;

/* Controlo los parametros */
  if ( argc != 3 )
  {
    printf ( "\ndyld_patcher v1.01 for iPhone v1.1.4" );
    printf ( "\nCreated by Nicolas A. Economou ( neconomou@corest.com )" );
    printf ( "\nCore Security Technologies, Buenos Aires, Argentina ( 2008 )\n" );
    printf ( "\nusage: dyld_patcher dyld_source dyld_dest\n" );
    printf ( "example: dyld_patcher dyld dyle\n" );
    return ( 0 );
  }

/* No permito que el archivo destino sea el origen */
  if ( strcmp ( argv [ 1 ] , argv [ 2 ] ) == 0 )
  {
    printf ( "\ndestination dyld should be distinct to source dyld !\n" );
    return ( 0 );
  }

/* Si no pude abrir el 'dyld' */
  if ( ( dyld_source = fopen ( argv [ 1 ] , "rb" ) ) == NULL )
  {
    printf ( "\ncannot open dyld !\n" );
    return ( 0 );
  }

/* Chequeo si es realmente el dyld que soporta este programa */
  if ( is_correct_version ( dyld_source ) == TRUE )
  {
  /* Creo el file de destino */
    dyld_dest = fopen ( argv [ 2 ] , "w+b" );

  /* Si pude abrir el archivo de destino */
    if ( dyld_dest != NULL )
    {
    /* Me posiciono al inicio del file original */
      fseek ( dyld_source , 0 , SEEK_SET );

    /* Mientras haya bytes por leer */
      while ( fread ( &c , 4 , 1 , dyld_source ) == 1 )
      {
      /* Copio el byte al file de destino */
        fwrite ( &c , 4 , 1 , dyld_dest );
      }

    /* Me aseguro que la data se haya escrito */
      fflush ( dyld_dest );

    /* Mensaje al usuario */
      printf ( "\nreplacing ...\n" );

    /* Patcheo el file */
      for ( pos = 0 ; pos < ( sizeof ( change_table ) / ( sizeof ( int ) * 5 ) ) ; pos ++ )
      {
      /* Mensaje al usuario */
        printf ( "\n0x%x: %s by \t%s" , change_table [ pos ] [ 0 ] , ( char * ) change_table [ pos ] [ 3 ] , ( char * ) change_table [ pos ] [ 4 ] );

      /* Me posiciono en el byte a patchear */
        fseek ( dyld_dest , ( unsigned long ) change_table [ pos ] [ 0 ] , SEEK_SET );

      /* Byte a reemplazar */
        c = change_table [ pos ] [ 2 ];

      /* Piso el byte original por uno mio */
        fwrite ( &c , 4 , 1 , dyld_dest );
      }
    }

  /* Mensaje al usuario */
    printf ( "\n\ndone.\n" );
  }
  else
  {
    printf ( "\ndyld version not supported !\n" );
  }

/* Cierro los files */
  fclose ( dyld_source );
  fclose ( dyld_dest );

  return ( 1 );
}

/****************************************************************************/

int is_correct_version ( FILE *dyld_source )
{
  unsigned int pos;
  int ret = TRUE;
  int b, c;

/* Recorro toda la lista checkeando si los bytes coinciden */
  for ( pos = 0 ; pos < ( sizeof ( change_table ) / ( sizeof ( int ) * 5 ) ) ; pos ++ )
  {
  /* Me posiciono en uno de los bytes a cambiar */
    fseek ( dyld_source , change_table [ pos ] [ 0 ] , SEEK_SET );

  /* Levanto el byte del file original */
    fread ( &b , 4 , 1 , dyld_source );

  /* Byte a comparar */
    c = change_table [ pos ] [ 1 ];

  /* Si este byte no coincide */
    if ( b != c )
    {
    /* Retorno ERROR */
      return ( FALSE );
    }
  }

  return ( ret );
}

/****************************************************************************/

